freeslot("SKINCOLOR_HYPERMETALCLONE") //For later!

local function superemeraldcheck(player)
	if gametype == GT_COOP or gametype == GT_COMPETITION or gametype == GT_RACE then
		if not All7Emeralds(emeralds) then
			P_SpawnMobj(player.mo.x,player.mo.y,player.mo.z, MT_EMERALD1)
			P_SpawnMobj(player.mo.x,player.mo.y,player.mo.z, MT_EMERALD2)
			P_SpawnMobj(player.mo.x,player.mo.y,player.mo.z, MT_EMERALD3)
			P_SpawnMobj(player.mo.x,player.mo.y,player.mo.z, MT_EMERALD4)
			P_SpawnMobj(player.mo.x,player.mo.y,player.mo.z, MT_EMERALD5)
			P_SpawnMobj(player.mo.x,player.mo.y,player.mo.z, MT_EMERALD6)
			P_SpawnMobj(player.mo.x,player.mo.y,player.mo.z, MT_EMERALD7)
		end
	end
end

addHook("PlayerThink", superemeraldcheck) //Can't go super, WITHOUT THE EMERALDS

local function superforall(player)
	if player.mo and player.valid then
		if not (player.charflags & SF_SUPER) then
			player.charflags = $1 + SF_SUPER
		end
	end
end

addHook("PlayerThink", superforall) //Make sure EVERYONE has fun!

addHook("PlayerThink", function(player)
	if gametype == GT_COOP and player.distributesuper == 1 then
		if player.mo and player.valid and All7Emeralds(emeralds) and not player.exiting then
			if (player.rings < 1) and not player.powers[pw_super] then
				player.mo.state = S_PLAY_SUPER_TRANS1
				S_StartSound(player.mo, sfx_supert)
				player.rings = $1 + 2
				player.powers[pw_super] = 1
			elseif (player.rings < 2) then
				player.rings = $1 + 1
			end //Distribute type 1, prevents rings going under 2
		end
	end
end)

addHook("PlayerThink", function(player)
if not (G_BuildMapName(mapnum) == "MAP59" or G_BuildMapName(mapnum) == "MAP25") //No cheating EX.Metal, or Hyper Metal.
	if gametype == GT_COOP and player.boosttype == 1 then
		if player.powers[pw_super] and player.powers[pw_sneakers]
			if player.abilboostflag == 0
				player.actionspd = $1*(player.boostpower)
			end
		player.abilboostflag = 1
		else
			if player.abilboostflag == 1
				player.actionspd = $1/(player.boostpower)
			end
		player.abilboostflag = 0
		end
	elseif gametype == GT_COOP and player.boosttype == 2 then
		if player.powers[pw_super] and player.powers[pw_invulnerability]
			if player.abilboostflag == 0
				player.actionspd = $1*(player.boostpower)
			end
		player.abilboostflag = 1
		else
			if player.abilboostflag == 1
				player.actionspd = $1/(player.boostpower)
			end
		player.abilboostflag = 0
		end
	elseif gametype == GT_COOP and player.boosttype == 3 then
	if player.powers[pw_super]
			if player.abilboostflag == 0
				player.actionspd = $1*(player.boostpower)
			end
		player.abilboostflag = 1
		else
			if player.abilboostflag == 1
				player.actionspd = $1/(player.boostpower)
			end
		player.abilboostflag = 0
		end
	end
end
end) //These are for boosing your actionspd based on superrun_abilityboost_power

addHook("PlayerThink", function(player)
if not (G_BuildMapName(mapnum) == "MAP59" or G_BuildMapName(mapnum) == "MAP25")
	if gametype == GT_COOP and player.multitype == 1 then
		if player.powers[pw_super] and player.powers[pw_sneakers]
			if player.multiabilflag == 0
				player.charflags = $1|SF_MULTIABILITY
			end
		player.multiabilflag = 1
		else
			if player.multiabilflag == 1
				player.charflags = $1 & ~SF_MULTIABILITY
			end
		player.multiabilflag = 0
		end
	elseif gametype == GT_COOP and player.multitype == 2 then
		if player.powers[pw_super] and player.powers[pw_invulnerability]
			if player.multiabilflag == 0
				player.charflags = $1|SF_MULTIABILITY
			end
		player.multiabilflag = 1
		else
			if player.multiabilflag == 1
				player.charflags = $1 & ~SF_MULTIABILITY
			end
		player.multiabilflag = 0
		end
	elseif gametype == GT_COOP and player.multitype == 3 then
		if player.powers[pw_super]
			if player.multiabilflag == 0
				player.charflags = $1|SF_MULTIABILITY
			end
		player.multiabilflag = 1
		else
			if player.multiabilflag == 1
				player.charflags = $1 & ~SF_MULTIABILITY
			end
		player.multiabilflag = 0
		end
	end
end
end) //Spamming is fun :3 so why not make it a feature-

addHook("PlayerThink", function(player)
if not (G_BuildMapName(mapnum) == "MAP59" or G_BuildMapName(mapnum) == "MAP25")
	if gametype == GT_COOP and player.arceustype == 1 then
		if player.powers[pw_super] and player.multiabilflag == 1 and player.abilboostflag == 1
			if player.arceustime == 0
				player.pflags = $1|PF_GODMODE
			end
		player.arceustime = 1
		else
			if player.arceustime == 1
				player.pflags = $1 & ~PF_GODMODE
			end
		player.arceustime = 0
		end
	elseif gametype == GT_COOP and player.arceustype == 2 then
		if player.powers[pw_super]
			if player.arceustime == 0
				player.pflags = $1|PF_GODMODE
			end
		player.arceustime = 1
		else
			if player.arceustime == 1
				player.pflags = $1 & ~PF_GODMODE
			end
		player.arceustime = 0
		end
	end	
end
end) //Hyper..
	


addHook("MapLoad", do
	for player in players.iterate
		if player.mo and player.valid and gametype == GT_COOP and player.distributesuper == 2 then
			player.rings = 50
		end
	end
end) //	Distribution type 2!

addHook("PlayerThink", function(player)
    if gametype == GT_COOP and player.distributesuper == 3 then
		if player.mo and player.valid and not player.exiting and player.rings == 0 then
		player.rings = 50
		end
	end
end) //Type 3!

addHook("PlayerThink", function(player)
	if gametype == GT_COOP and player.distributesuper == 4 then
		if player.mo and player.valid and not player.exiting then
			player.rings = 9999
		end
	end //Distribute type 4, always at max!
end)

addHook("PlayerThink", function(player)
	if gametype == GT_COOP and player.distributesuper == 5 then
		if player.mo and player.valid and not player.exiting then
			if (player.rings < 9999) and not (leveltime%35) and not player.powers[pw_super] then
				player.rings = $1 + 1
			end //Distribute type 5, Increases rings when not super!
		end
	end
end)

addHook("PlayerThink", function(player)
	if gametype == GT_COOP and player.distributesuper == 6 then
		if player.mo and player.valid and not player.exiting then
			if (player.rings > 0) and not (leveltime%35) and not player.powers[pw_super] then
				player.rings = $1 - 1
			end //Distribute type 6, always lose rings..!
		end
	end
end)


addHook("PlayerThink", function(player)
    if gametype == GT_COOP then
		if player.mo and player.valid and not player.exiting and (player.rings > 0) and All7Emeralds(emeralds) and player.wepchancooldown == 0 and player.nextprevsupyes == 1 and not player.powers[pw_carry] then
			if (player.cmd.buttons & BT_WEAPONNEXT) and not player.powers[pw_super]
				player.mo.momz = 0
				player.mo.momx = 0
				player.mo.momy = 0
				player.powers[pw_super] = 1
				player.mo.state = S_PLAY_SUPER_TRANS1
				S_StartSound(player.mo, sfx_s3k46)
				player.wepchancooldown = 55
			elseif (player.cmd.buttons & BT_WEAPONPREV) and player.powers[pw_super]
				player.powers[pw_super] = 0
				S_StartSound(player.mo, sfx_s3k9c)
				player.mo.color = player.skincolor
				player.mo.state = player.mo.state
				player.wepchancooldown = 55
				P_SpawnShieldOrb(player)
				P_RestoreMusic(player) //This is new :o Why? For the music update!
			end
		end
	end
end) //The lines to Force Super! And not do that!

addHook("PlayerThink", function(player)
    if gametype == GT_COMPETITION then
		if player.mo and player.valid and All7Emeralds(emeralds) and not player.exiting then
			if (player.rings < 1) and not player.powers[pw_super] then
				player.mo.state = S_PLAY_SUPER_TRANS1
				S_StartSound(player.mo, sfx_s3k46)
				player.rings = 2
				player.powers[pw_super] = 1
			elseif (player.rings < 2) then
				player.rings = 2
			end
		end
	end
end) 

//Competition and race play by different rules.
//Don't lose all your rings in race.. That's a hefty stall.

addHook("PlayerThink", function(player)
    if gametype == GT_RACE then
		if player.mo and player.valid and All7Emeralds(emeralds) and not player.exiting then
			if (player.rings < 1) and not player.powers[pw_super] then
				player.powers[pw_super] = 1
				player.rings = 10
				player.mo.state = S_PLAY_SUPER_TRANS1
				S_StartSound(player.mo, sfx_s3k9f)
			end
		end
	end
end)

addHook("MapLoad", do
	for player in players.iterate
		if player.mo and player.valid and gametype == GT_RACE then
			player.rings = 54
		end //Start time drains rings, so 4 bonus rings to match 50 to go!
	end
end)

//Music!
addHook("PlayerThink", function(player)
if not (G_BuildMapName(mapnum) == "MAP59" or G_BuildMapName(mapnum) == "MAP25")
	if player.mo and player.valid and not player.exiting then
		if player.superrunmusic == 1 then
			if player.powers[pw_super] and not player.powers[pw_extralife] then //Don't want the 1-up jingle and Super Music to overlap.. That don't sound cool!
				if (player.mo.skin == "sonic") then
				S_ChangeMusic("SUPSON", true, player)
				elseif (player.mo.skin == "tails") then
				S_ChangeMusic("SUPTAL", true, player)
				elseif (player.mo.skin == "knuckles") then
				S_ChangeMusic("SUPKNX", true, player)
				elseif (player.mo.skin == "amy") then
				S_ChangeMusic("SUPAMY", true, player)
				elseif (player.mo.skin == "fang") then
				S_ChangeMusic("SUPFNG", true, player)
				elseif (player.mo.skin == "metalsonic") then
				S_ChangeMusic("SUPMET", true, player)
				end
			end
		elseif player.superrunmusic == 2 then
			if player.powers[pw_super] and not player.powers[pw_extralife] and (player.pflags & PF_GODMODE) then
				if (player.mo.skin == "sonic") then
				S_ChangeMusic("HYPSON", true, player)
				elseif (player.mo.skin == "tails") then
				S_ChangeMusic("HYPTAL", true, player)
				elseif (player.mo.skin == "knuckles") then
				S_ChangeMusic("HYPKNX", true, player)
				elseif (player.mo.skin == "amy") then
				S_ChangeMusic("HYPAMY", true, player)
				elseif (player.mo.skin == "fang") then
				S_ChangeMusic("HYPFNG", true, player)
				elseif (player.mo.skin == "metalsonic") then
				S_ChangeMusic("HYPMET", true, player)
				end
			end
		elseif player.superrunmusic == 3 then
			if player.powers[pw_super] and not player.powers[pw_extralife] then
				S_ChangeMusic("_SUPER", true, player)
			end
		elseif player.superrunmusic == 4 then //Does do stuff for vanilla now :3
			if player.powers[pw_super] and not player.powers[pw_extralife] and not (player.pflags & PF_GODMODE) then
				if (player.mo.skin == "sonic") then
				S_ChangeMusic("SUPSON", true, player)
				elseif (player.mo.skin == "tails") then
				S_ChangeMusic("SUPTAL", true, player)
				elseif (player.mo.skin == "knuckles") then
				S_ChangeMusic("SUPKNX", true, player)
				elseif (player.mo.skin == "amy") then
				S_ChangeMusic("SUPAMY", true, player)
				elseif (player.mo.skin == "fang") then
				S_ChangeMusic("SUPFNG", true, player)
				elseif (player.mo.skin == "metalsonic") then
				S_ChangeMusic("SUPMET", true, player)
				end
			elseif player.powers[pw_super] and not player.powers[pw_extralife] and (player.pflags & PF_GODMODE) then
				if (player.mo.skin == "sonic") then
				S_ChangeMusic("HYPSON", true, player)
				elseif (player.mo.skin == "tails") then
				S_ChangeMusic("HYPTAL", true, player)
				elseif (player.mo.skin == "knuckles") then
				S_ChangeMusic("HYPKNX", true, player)
				elseif (player.mo.skin == "amy") then
				S_ChangeMusic("HYPAMY", true, player)
				elseif (player.mo.skin == "fang") then
				S_ChangeMusic("HYPFNG", true, player)
				elseif (player.mo.skin == "metalsonic") then
				S_ChangeMusic("HYPMET", true, player)
				end
			end
		end
	end
end
end) //Pog!
//Music won't be thaat good bc I wanna try and save on filesize!
//Sonic and Metal get special treatment :p
//Not good at comments so please, do excuse me

addHook("MobjThinker", function(mobj) //Hyper Metal's colouring! Cute..
	if G_BuildMapName(mapnum) == "MAP59" then
		if mobj.colorized == true then
			mobj.color = SKINCOLOR_HYPERMETALCLONE
		else
			mobj.color = SKINCOLOR_HYPERMETALCLONE
		end
		if not (leveltime%30) then
			P_SpawnMobj(mobj.x,mobj.y,mobj.z, MT_SUPERSPARK)
		end
		if not (leveltime%2) then
			local BOXMET = P_SpawnMobj(mobj.x,mobj.y,mobj.z, MT_DUST)
			BOXMET.fuse = 3*TICRATE
			BOXMET.momz = 2*FRACUNIT
		end
	end
end, MT_METALSONIC_RACE)

//Needs to exist first... Axew you idiot..
skincolors[SKINCOLOR_HYPERMETALCLONE] = {
    name = "Metal Sonic's Hyper Colours",
    ramp = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
    invshade = 9,
    accessible = false
}


//Metal's colour in action, tried to make it a bit different from the usual Hyper, assuming I',m using the correct ramps..
local function MetalHyperSkin()//I dunno what to put in here so let's hope it works (It did, pog)
	if (leveltime % 28) >= 0 and (leveltime % 28) <= 2
        skincolors[SKINCOLOR_HYPERMETALCLONE].ramp = skincolors[SKINCOLOR_SUPERGOLD1].ramp
    elseif (leveltime % 28) >= 2 and (leveltime % 28) <= 4
        skincolors[SKINCOLOR_HYPERMETALCLONE].ramp = skincolors[SKINCOLOR_SUPERTAN1].ramp
    elseif (leveltime % 28) >= 4 and (leveltime % 28) <= 6
        skincolors[SKINCOLOR_HYPERMETALCLONE].ramp = skincolors[SKINCOLOR_SUPERSILVER1].ramp
    elseif (leveltime % 28) >= 6 and (leveltime % 28) <= 8
        skincolors[SKINCOLOR_HYPERMETALCLONE].ramp = skincolors[SKINCOLOR_SUPERGOLD1].ramp
    elseif (leveltime % 28) >= 8 and (leveltime % 28) <= 10
        skincolors[SKINCOLOR_HYPERMETALCLONE].ramp = skincolors[SKINCOLOR_SUPERPERIDOT1].ramp
    elseif (leveltime % 28) >= 10 and (leveltime % 28) <= 12
        skincolors[SKINCOLOR_HYPERMETALCLONE].ramp = skincolors[SKINCOLOR_SUPERSKY1].ramp
    elseif (leveltime % 28) >= 12 and (leveltime % 28) <= 14
        skincolors[SKINCOLOR_HYPERMETALCLONE].ramp = skincolors[SKINCOLOR_SUPERPURPLE1].ramp
    elseif (leveltime % 28) >= 14 and (leveltime % 28) <= 16
        skincolors[SKINCOLOR_HYPERMETALCLONE].ramp = skincolors[SKINCOLOR_SUPERPERIDOT1].ramp
    elseif (leveltime % 28) >= 16 and (leveltime % 28) <= 18
        skincolors[SKINCOLOR_HYPERMETALCLONE].ramp = skincolors[SKINCOLOR_SUPERRED1].ramp
    elseif (leveltime % 28) >= 18 and (leveltime % 28) <= 20
        skincolors[SKINCOLOR_HYPERMETALCLONE].ramp = skincolors[SKINCOLOR_SUPERTAN1].ramp
    elseif (leveltime % 28) >= 20 and (leveltime % 28) <= 22
        skincolors[SKINCOLOR_HYPERMETALCLONE].ramp = skincolors[SKINCOLOR_SUPERRUST1].ramp
    elseif (leveltime % 28) >= 22 and (leveltime % 28) <= 24
        skincolors[SKINCOLOR_HYPERMETALCLONE].ramp = skincolors[SKINCOLOR_SUPERPERIDOT1].ramp
    elseif (leveltime % 28) >= 24 and (leveltime % 28) <= 26
        skincolors[SKINCOLOR_HYPERMETALCLONE].ramp = skincolors[SKINCOLOR_SUPERPURPLE1].ramp
    elseif (leveltime % 28) >= 26 and (leveltime % 28) <= 28
        skincolors[SKINCOLOR_HYPERMETALCLONE].ramp = skincolors[SKINCOLOR_SUPERGOLD1].ramp
    end
end
addHook("ThinkFrame", MetalHyperSkin) //Needs,,,,,,,,to work lol, cant just expect it to think by itself :p
//...Huh. Sounds like me..